#!/usr/bin/perl

use Sys::Hostname;



# jack - forced host to be jenkins, otherwise it's wrong
#$host = hostname;
$host = "jenkins";

# Only admins can view and manage SVN users
@valid_admins=qw(abartol jflynn build karoyan mmorley kbusch mvictory gdavis jfournier rmeyer);

##################################
# To put offline for maintenance
##################################
$offline="no";
#$offline="yes";

$mylogo="https://$host.bit9.local/CB+Digital.JPG";
$mypic="https://$host.bit9.local/release-the-kraken.png";
$mytitle="Create Subversion Branches for Das, DasThirdParty, bit9installers and build repositories";
$mycss="hotfixes.css";

if ($offline eq "yes" ) {

print<<EOF;

<html>
<head>
<title>$mytitle</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
<link rel="stylesheet" href="$mycss" type="text/css"/>
<body>

<p><img src="$mylogo" width="200" height=80></p>

<h1><font color="red">Temporarily down for maintenance</font></h1>
We expect to be up shortly. Thanks for your patience.
</body>
</html>

EOF

exit 1;
}

$admin=0;
foreach $valid_admin (@valid_admins) {
	$admin=1 if ( $ENV{REMOTE_USER} eq "$valid_admin" );
}
open(OO, ">/tmp/ll.txt");
$ooo = `env`;
print OO "$ooo\n";
close(OO);
$admin=1;

if (!$admin) {
	&doHeader;
	print "<br><font color=\"red\"><b>ERROR:</b> Don't be silly. You are not an authorized user for this utility. Cannot proceed with your request. Please see an Administrator for assistance.</font><br>";
	print "</body></html>\n";
	exit 1;
}

use File::Basename;
use IO::Handle;
use Data::Dumper;

$thisscript=basename($0);
$progdir=dirname($0);
($thisscript_strip_cgi_ext = $thisscript) =~ s/\.cgi//g;

# So I can change the test script before making it live
if ( "$thisscript" eq "create-svn-branch.cgi" ) {
	$http_name="svnbranch";
	$svn_auth_page="https://subversion.bit9.local/svnauth";
	$branches_file="/transfer/release-branches/latest-live.txt";
	$mode="live";
} else {
	$http_name="svnbranch-test";
	$svn_auth_page="https://subversion.bit9.local/svnauth-test";
	$branches_file="/transfer/release-branches/latest-test.txt";
	$mode="test";
}

# jack - now that i have ssh working against svn, use ssh rather than stored password for build
system("svn ls svn+ssh://build\@subversion.bit9.local/opt/svn/repos/Das/release_branches > $branches_file");
#system("svn ls --username build https://subversion.bit9.local/svn/Das/release_branches > $branches_file");

# jack - test wget on my monitor slaves job for chuckles
# worked fine
# system("wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/ci/job/Monitor_Slaves/build?token=TOKEN");

$DEBUG=1;
$debuglog="/tmp/$thisscript_strip_cgi_ext.out";
open(DEBUGOUT, ">>$debuglog") if ($DEBUG);
print DEBUGOUT "In $thisscript_strip_cgi_ext\n";
print DEBUGOUT "ENV{REQUEST_URI} is \"$ENV{REQUEST_URI}\"\n";
#print DEBUGOUT Dumper \%ENV;

sub printErrorAndDie() {
	print "<p><font color=red><b>ERROR: </b></font> $_[0]<p>\n";
	print "</body></html>\n";
	&restore_stdout;
	exit 1;
}

sub ReadParse {
	local (*in) = @_ if @_;
	local ($i, $loc, $key, $val);

	# Read in text
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$in = $ENV{'QUERY_STRING'};
	} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
	}

	@in = split(/&/,$in);

	#print DEBUGOUT "Now in ReadParse\n" if ($DEBUG);

	foreach $i (0 .. $#in) {
		print DEBUGOUT "Now in ReadParse foreach\n" if ($DEBUG);
		# Convert pluses to spaces
		$in[$i] =~ s/\+/ /g;

		# Split into key and value.
		($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

		# Convert %XX from hex numbers to alphanumeric
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		$val =~ s/%(..)/pack("c",hex($1))/ge;

		# Associate key and value
		$in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
		$in{$key} .= $val;

		#print DEBUGOUT "YYY key is \"$key\"\n" if ($DEBUG);
		#print DEBUGOUT "YYY val is \"$val\"\n" if ($DEBUG);

		if ( $key =~ /branchBuildRepo/ ) {
			$branchBuildRepo="$val";
			print DEBUGOUT "YYY branchBuildRepo is \"$branchBuildRepo\"\n" if ($DEBUG);
		} elsif ( $key =~ /newBranchName/ ) {
			$newBranchName="$val";
			#print DEBUGOUT "newBranchName is \"$newBranchName\"\n" if ($DEBUG);
		} elsif ( $key =~ /BranchFrom/ ) {
			$BranchFrom="$val";
			#print DEBUGOUT "BranchFrom is \"$BranchFrom\"\n" if ($DEBUG);
		} elsif ( $key =~ /SubversionCommitComment/ ) {
			$SubversionCommitComment="$val";
			#print DEBUGOUT "SubversionCommitComment is \"$SubversionCommitComment\"\n" if ($DEBUG);
		}
	}
}

sub doHeader {
	# Do not put this line in the print EOF section
	print "Content-type:text/html\r\n\r\n";

print<<EOF;
<html>
<head>
<title>$mytitle</title>
<link rel="stylesheet" href="$mycss" type="text/css"/>
</head>
<body>

<p><img src="$mylogo" width="300" height=80></p>

EOF
}

sub doGetHeader {

print<<EOF;
<table border="1" width="90%">

<form name="myform" action="https://$host.bit9.local/$http_name?confirmConfig" method="POST">

<h2>Create SVN branches from mainline and bump versions in version.h and PatchNumber.txt files and commit</h2>

Bit9 Platform <b><i>Branch-From</b></i> Version :
<SELECT NAME="BranchFrom" >

EOF

# Sort strings with numbers in a natural ascending order
@ascending_sorted_branches = @sorted_branches[
    map { unpack "N", substr($_,-4) }
    sort
    map {
        my $key = $sorted_branches[$_];
        $key =~ s[(\d+)][ pack "N", $1 ]ge;
        $key . pack "N", $_
    } 0..$#sorted_branches
];
@sorted_branches = reverse(@ascending_sorted_branches);

foreach $branch (@sorted_branches) {
 chop $branch;
 print "<option value=\"$branch\">$branch</option>\n";
}

print<<EOF;
</SELECT>
(Name of the SVN Branch you want to branch <b><i>from</b></i>)

<p>
New Branch name:
<INPUT NAME="newBranchName" size="50">
(The name of the new branch you want to create)

<p>
Also branch <b>build</b> repository?:
<INPUT NAME="branchBuildRepo" TYPE="radio" VALUE="No" CHECKED>No
<INPUT NAME="branchBuildRepo" TYPE="radio" VALUE="Yes">Yes

<!--
<p>
TestTrack Change Request numbers :
<INPUT NAME="TestTrackNumbers" size="50">
</SELECT>
(Multiple TestTrack numbers must be comma or space separated)
-->

<!--
<p>
Branch Subversion Commit Comment:
<INPUT NAME="SubversionCommitComment" size="50">
</SELECT>
(The Subverison commit comment to be used when creating the SVN branches)
-->

<p>
<input type="submit" value="Submit">
</form>

<p><img src="$mypic"></p>

EOF

}

sub doApplyConfig {

	# These variables should be set by the time this subroutine is called
	# TestTrackNumbers=$TestTrackNumbers
	# BranchFrom=$BranchFrom
	# newBranchName=$newBranchName
	# SubversionCommitComment=$SubversionCommitComment

	@necessary_arguments=();
	push (@necessary_arguments, "$branchBuildRepo", "$newBranchName", "$BranchFrom", "$SubversionCommitComment");

	# Force redirect to main page if variables aren't set
	foreach $necessary_argument (@necessary_arguments) {
		if ( "$necessary_argument" !~ m/./ ) {
			print "Content-Type: text/html\n\n";
			print "<META HTTP-EQUIV=refresh CONTENT=\"0;URL=https://$host.bit9.local/$http_name\">\n";
		}
	}

	print<<EOF;

<table border="1" width="90%">

<h2>Your Branch Is Being Created</h2>

<table border="1">
<tr>
<td><u>Description</u></td>
<td><u>Values</u></td>
<td><u>Additional Information</u></td>
</tr>
<tr>
<td>New Branch:</td>
<td><b>$newBranchName</b></td>
<td>Your new Branch Name</td>
</tr>
<tr>
<td>Branching Build Repository:</td>
<td> <b>$branchBuildRepo</b></td>
<td>Will the build repository be branched?</td>
</tr>
<tr>
<td>Branch From:</td>
<td><b>$BranchFrom</b></td>
<td>Subversion branch point</td>
</tr>
<tr>
<td>Subversion Commit Comment:</td>
<td><b>$SubversionCommitComment</b></td>
<td>SVN commit message</td>
</tr>
<tr>
<td>Your Email Address:</td>
<td><b>$ENV{REMOTE_USER}\@bit9.com</b></td>
<td>Email address you will receive final notification</td>
</tr>
</table>

<p>
<br>

<table border="1">
<tr>
<td>This will take a minute. You will receive an email when your new branches are ready for use.</td>
</tr>
</table>

EOF


# jack - test wget on my monitor slaves job for chuckles
# worked fine
# system("wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/ci/job/Monitor_Slaves/build?token=TOKEN");

# jack's updates to work with new password hash and TOKEN
print DEBUGOUT "wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/ci/job/Create_Subversion_Branches/buildWithParameters?token=TOKEN\&delay=0sec\&mode=$mode\&runby=$ENV{'REMOTE_USER'}\&branchBuildRepo=$branchBuildRepo\&newBranchName=$newBranchName\&BranchFrom=$BranchFrom\&SubversionCommitComment=$SubversionCommitComment\n" if ($DEBUG);

system("wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 \"https://jenkins.bit9.local/ci/job/Create_Subversion_Branches/buildWithParameters?token=TOKEN\&delay=0sec\&mode=$mode\&runby=$ENV{'REMOTE_USER'}\&branchBuildRepo=$branchBuildRepo\&newBranchName=$newBranchName\&BranchFrom=$BranchFrom\&SubversionCommitComment=$SubversionCommitComment\"");

#print DEBUGOUT "wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=2a19f9d3a817e3eb49b154183be46104 https://jenkins.bit9.local/ci/job/Create_Subversion_Branches/buildWithParameters?token=BIT9_TOKEN\&delay=0sec\&mode=$mode\&runby=$ENV{'REMOTE_USER'}\&branchBuildRepo=$branchBuildRepo\&newBranchName=$newBranchName\&BranchFrom=$BranchFrom\&SubversionCommitComment=$SubversionCommitComment\n" if ($DEBUG);

#system("wget -O /dev/null --no-check-certificate --auth-no-challenge --http-user=build --http-password=2a19f9d3a817e3eb49b154183be46104 \"https://jenkins.bit9.local/ci/job/Create_Subversion_Branches/buildWithParameters?token=BIT9_TOKEN\&delay=0sec\&mode=$mode\&runby=$ENV{'REMOTE_USER'}\&branchBuildRepo=$branchBuildRepo\&newBranchName=$newBranchName\&BranchFrom=$BranchFrom\&SubversionCommitComment=$SubversionCommitComment\"");

}

sub doPutHeader {

print DEBUGOUT "branchBuildRepo is \"$branchBuildRepo\"\n" if ($DEBUG);
print DEBUGOUT "BranchFrom is \"$BranchFrom\"\n" if ($DEBUG);
print DEBUGOUT "newBranchName is \"$newBranchName\"\n" if ($DEBUG);

# TestTrackNumbers is "28499-28663"
# BranchFrom is "Ares-7.0.1-V2-P10"
# newBranchName is "Ares-7.0.1-V2-HF16-CR-28499-28663"

@necessary_arguments=();
#push (@necessary_arguments, "$TestTrackNumbers", "$BranchFrom", "$newBranchName", "$SubversionCommitComment");
push (@necessary_arguments, "$branchBuildRepo", "$newBranchName", "$BranchFrom");

print DEBUGOUT "branchBuildRepo is \"$branchBuildRepo\"\n" if ($DEBUG);
print DEBUGOUT "BranchFrom is \"$BranchFrom\"\n" if ($DEBUG);
print DEBUGOUT "newBranchName is \"$newBranchName\"\n" if ($DEBUG);

# Force redirect to main page if variables aren't set
foreach $necessary_argument (@necessary_arguments) {
	if ( "$necessary_argument" !~ m/./ ) {
		print "Content-Type: text/html\n\n";
		print "<META HTTP-EQUIV=refresh CONTENT=\"0;URL=https://$host.bit9.local/$http_name\">\n";
	}
}

$SubversionCommitComment="New $newBranchName branch created from $BranchFrom";
print DEBUGOUT "SubversionCommitComment is \"$SubversionCommitComment\"\n" if ($DEBUG);
print DEBUGOUT "branchBuildRepo is \"$branchBuildRepo\"\n" if ($DEBUG);

if ( $branchBuildRepo eq "No" ) {
	$buildRepoMsg = "The <b>build</b> repository <b><i>will not be</b></i> branched.";
	$buildRepos = "<b><i>Das</b></i>, <b><i>DasThirdParty</b></i> and <b><i>bit9installers</b></i>";
} else {
	$buildRepoMsg = "The <b>build</b> repository <b><i>will be</b></i> branched.";
	$buildRepos = "<b><i>Das</b></i>, <b><i>DasThirdParty</b></i>, <b><i>bit9installers</b></i> and <b><i>build</b></i>";
}

print<<EOF;
<table border="1" width="90%">

<form name="myform" action="https://$host.bit9.local/$http_name?applyConfig" method="POST">

<h2>Your New Branch Configuration</h2>

Branch From: <b>$BranchFrom</b>
<br>Branch Build repository: <b>$branchBuildRepo</b>
<br>Subversion Commit Comment: <b>$SubversionCommitComment</b>
<br>Your Current Email Address: <b>$ENV{REMOTE_USER}\@bit9.com</b>

<br>
<br>New Branch: <b>$newBranchName</b> <- This will be your new Branch Name
<p>
<font color=red><b>IMPORTANT:</font></b> Once you click the <b>Yes</b> button below, the following will happen:
<br><li>You will create the <b>$newBranchName</b> SVN branch in the $buildRepos repositories
<br><li>Your branches will be created using the latest versions of the <b>$BranchFrom</b> branch as your branch point
<br><li>The SVN global authorization file will have your new branches added
<br><li>The <a href="$svn_auth_page" target=_blank>$svn_auth_page</a> SVN auth page will be updated
<br><li>The <b>$BranchFrom</b> <b><i>Das/Common/Include/version.h</b></i> file will be bumped up by 30
<br><li>The <b>$BranchFrom</b> <b><i>bit9installers/Server/Server_Patch/Misc/PatchNumber.txt</b></i> file will be incremented by 1
<br><li>$buildRepoMsg

<br>
<br>Please make absolutely sure your request is correct. If you need to change anything, click the <b>No</b> button.
<br>
<br>Are you sure you want to continue with your request?
<p>

<input type="hidden" name="branchBuildRepo" value="$branchBuildRepo" />
<input type="hidden" name="BranchFrom" value="$BranchFrom" />
<input type="hidden" name="newBranchName" value="$newBranchName" />
<input type="hidden" name="SubversionCommitComment" value="$SubversionCommitComment" />

<input type="submit" value="Yes">
</form>

<form name="myform" action="https://$host.bit9.local/$http_name" method="POST">
<input type="submit" value="No">
</form>

EOF

}

sub restore_stdout {
	close STDOUT;
	# Restore original STDOUT 
	open (STDOUT, ">&ORIGSTDOUT") or die "Can't restore STDOUT: $!"; 
	close ORIGSTDOUT; 
	#system("cat $TF1 | sed s/FILES_CHANGED/$count/g");
	system("cat $TF1");
	unlink("$TF1");
}

# I redirect STDOUT to a file so I can process the file and put info at the top
# of the output. For me to get the info I need, the script needs to run first so
# I can't just print to STDOUT directly.

$TF1="/tmp/tf1$$";
# Save original STDOUT
open (ORIGSTDOUT, ">&STDOUT") or die "Couldn't dup STDOUT: $!";
open (STDOUT, ">> $TF1") or die "Can't open $TF1: $!";

# This should never happen but if the /etc/httpd/conf.d/bit9-ssl.conf-EDITME file was
# fat fingered, its a possibility. Verify the /svnbranch and /svnbranch-test sections
# are correct.
if ( "$ENV{REMOTE_USER}" !~ m/./ ) {
	&doHeader;
	&printErrorAndDie("REMOTE_USER is not set so I don't know who you are. Please see your administrator for assistance.");
}

@branches=`cat $branches_file | egrep -v "Release702|retired|-RC|\-HF|Lepton|Trillian|Tera|Future|File_Submission"`;
#@branches=`/usr/bin/sudo -u build /usr/local/bit9/svn-ls-Das-branches.sh | egrep -v "Release702|retired|-RC|\-HF|Lepton|Trillian|Tera|Future|File_Submission"`;
chomp(@branches);

## Sort strings with numbers in a natural ascending order
#@ascending_sorted_branches = @branches[
    #map { unpack "N", substr($_,-4) }
    #sort
    #map {
        #my $key = $branches[$_];
        #$key =~ s[(\d+)][ pack "N", $1 ]ge;
        #$key . pack "N", $_
    #} 0..$#branches
#];
#@sorted_branches = reverse(@ascending_sorted_branches);
@sorted_branches = reverse(@branches);

print DEBUGOUT "ENV{'REQUEST_METHOD'} is \"$ENV{'REQUEST_METHOD'}\"\n" if ($DEBUG);

#if ( $ENV{'REQUEST_METHOD'} or $ENV{'REQUEST_METHOD'} eq "POST") {
#if ( $ENV{'REQUEST_METHOD'} ~= m/GET/ ) {

if ( $ENV{'REQUEST_METHOD'} eq "GET" ) {
	&doHeader;
	&doGetHeader;
	&ReadParse;
	print "</body></html>\n";
}

if ( $ENV{'REQUEST_METHOD'} eq "POST" and $ENV{REQUEST_URI} =~ m#confirmConfig# ) {
	print DEBUGOUT "Now in REQUEST_URI confirmConfig\n" if ($DEBUG);
	&doHeader;
	&ReadParse;
	&doPutHeader;
	print "</body></html>\n";
	&restore_stdout;
	exit(0);
}

if ( $ENV{'REQUEST_METHOD'} eq "POST" and $ENV{REQUEST_URI} =~ m#applyConfig# ) {
	print DEBUGOUT "Now in REQUEST_URI applyConfig\n" if ($DEBUG);
	&doHeader;
	&ReadParse;
	&doApplyConfig;
	print "</body></html>\n";
	&restore_stdout;
	exit(0);
}

if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
	&doHeader;
	&ReadParse;
	&doGetHeader;
	print "</body></html>\n";
}

&restore_stdout;

$datenow=`date`;
chomp $datenow;
print DEBUGOUT "Run $datenow by: $ENV{REMOTE_USER}\n";
#if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
	#print DEBUGOUT "TestTrack query: $TestTrackNumbers\n";
#}
close(DEBUGOUT) if ($DEBUG);

exit 0;
