#!/usr/bin/env python

import cgi
import urllib
import json

print "Content-Type: text/html"
print ""

form = cgi.FieldStorage()

form_branch = None
form_config = None
form_signing = None
form_product = None
if form.has_key('branch'):
    form_branch = form['branch'].value
if form.has_key('config'):
    form_config = form['config'].value
if form.has_key('signing'):
    form_signing = form['signing'].value
if form.has_key('product'):
    form_product = form['product'].value

# Determine branches and create select box
def get_branch_option(branch):
    selected = ''
    if form_branch == branch:
        selected = ' selected'
    return '        <option value="%s"%s>%s</option>' % (branch, selected, branch)

branches_url = 'https://jenkins.bit9.local/cgi-bin/cbp_branches.cgi'
branches_content = urllib.urlopen(branches_url)
branches = json.loads(branches_content.read())
options = "\n".join(get_branch_option(x) for x in branches)
branch_selectBox = """
    <select name='branch'>
%s
    </select>
""" % options

internal_selected = ' selected' if form_signing == 'internal' else ''
external_selected = ' selected' if form_signing == 'external' else ''
signing_selectBox = """
    <select name='signing'>
        <option value='internal'%s>Internal</option>
        <option value='external'%s>External</option>
    </select>
""" % (internal_selected, external_selected)

release_selected = ' selected' if form_config == 'Release' else ''
debug_selected = ' selected' if form_config == 'Debug' else ''
config_selectBox = """
    <select name='config'>
        <option value='Release'%s>Release</option>
        <option value='Debug'%s>Debug</option>
    </select>
""" % (release_selected, debug_selected)

server_selected = ' selected' if form_product == 'SERVER' else ''
winagent_selected = ' selected' if form_product == 'WINAGENT' else ''
redhat6agent_selected = ' selected' if form_product == 'RH6AGENT' else ''
redhat7agent_selected = ' selected' if form_product == 'RH7AGENT' else ''
osxagent_selected = ' selected' if form_product == 'OSXAGENT' else ''
product_selectBox = """
    <select name='product'>
        <option value='SERVER'%s>Server</option>
        <option value='WINAGENT'%s>Windows Agent</option>
        <option value='RH6AGENT'%s>RedHat 6 Agent</option>
        <option value='RH7AGENT'%s>RedHat 7 Agent</option>
        <option value='OSXAGENT'%s>OSX Agent</option>
    </select>
""" % ( server_selected, winagent_selected, redhat6agent_selected, redhat7agent_selected, osxagent_selected)

searchbox_str = 'Search'
if form_branch and form_config and form_signing and form_product:
    searchbox_str = 'Update'
submit_form = """
<form action='?' method='GET'>
%s
%s
%s
%s
    <input type='submit' value='%s'>
</form>
""" % (branch_selectBox, signing_selectBox, config_selectBox, product_selectBox, searchbox_str)

if form_branch and form_config and form_signing and form_product:
    get_build_url = 'https://jenkins.bit9.local/cgi-bin/cbp_search.cgi?'
    search_vars = 'config=%s&branch=%s&product=%s&signing=%s' % (form_config, form_branch, form_product, form_signing)
    request_url = get_build_url + search_vars
    request_content = urllib.urlopen(request_url)
    build_res = json.loads(request_content.read())
    if build_res:
        vars_to_include = {"BuildNumber": "Build Number", 'jira_ticket': 'Jira', 'svn_msg': "SVN Message", "svn_author": "SVN Author", 'modified': 'Published', 'actual_sha1': "SHA1 Digest"}
        output_json = '<ul>'
        output_json += '<li>Artifactory URL: <a href="%s">Link</a> (<a href="%s">Folder Contents</a>)</li>\n' % (build_res['url'], '/'.join(build_res['url'].split('/')[:-1]))
        output_json += '<li>Revision: <a href="https://subversion.bit9.local/cgi-bin/viewvc.cgi/?view=rev&root=Das&revision=%s">%s</a>' % (build_res['Revision'], build_res['Revision'])
        for var in vars_to_include:
            output_json += '<li>%s: %s</li>\n' % (vars_to_include[var], build_res[var])
        output_json += '</ul>'
        body = submit_form + output_json
    else:
        body = submit_form
else:
    body = submit_form
print "<html> <title> Build Search </title> <body> %s </body> </html>" % body
