#!/usr/bin/perl

# The Jenkins Generate_SVN_Hotfix_Branches_Database job creates the branch file this
# script uses to generate the next available Hotfix branch.

if ( "$ARGV[1]" !~ m/./ ) {
        print "Error: Invalid or missing arguments\n";
        print "Usage: $0 [branch name] [CRs]\n";
        print "Examples:\n";
        print "Single CR number -\n";
        print "   $0 Ares-7.0.1-V2 \"12345\"\n";
        print "Multiple CR number -\n";
        print "   $0 Ares-7.0.1-V2 \"12345 56789\"\n";
        print "Error: Supply a branch name. i.e LeptonV2-7.0.0 or Ares-7.0.1-V2 etc.\n";
        exit 1;
}

$HOSTNAME=`hostname`;
chomp $HOSTNAME;

#if ( $HOSTNAME ne "bpuvjnmascscl01" ) {
#	print "Error: Must be on host jenkins.bit9.local\n";
#	exit 1;
#}

$BRANCH="$ARGV[0]";
chomp $BRANCH;
$CRS="$ARGV[1]";
chomp $CRS;
$hotfix_branches_file="$ARGV[2]";
chomp $hotfix_branches_file;

# jack - adding new issue type arg (drom cgi fiels CR or EA)
$ISSUE_TYPE="$ARGV[3]";
chomp $ISSUE_TYPE;

# Force failure
#$hotfix_branches_file="/tmp/kjfhdjkfhfdkjfh";

exit 1 if ( ! -e "$hotfix_branches_file" );

@branches=`cat $hotfix_branches_file | grep "$BRANCH"`;

foreach $branch (@branches) {
	chomp $branch;
	# jack - added new issue type for jira issues - EA (old just doing -CR)
	#$branch =~ m/HF(.*)?-CR(.*)/;
	# jack - added new issue type for jira issues - EA (new doing both -CR and -EA)
	$branch =~ m/HF(\d+)(-CR|-EA)/;
	$str = $1;
	push(@branch_numbers, $str);
}

# sort numerically descending
@sorted_branch_numbers = sort {$b <=> $a} @branch_numbers;

$lastver=$sorted_branch_numbers[0];
$nextver=$lastver + 1;

# Only print the name itself, no other string. This value is used by the
# next-available-hotfix.cgi script and only expects this string.
#print "\"${BRANCH}-HF${nextver}-CR-${CRS}\"\n";

# jack - using new issue type arg (no longer just CR but choice of CR/EA)
#print "${BRANCH}-HF${nextver}-CR-${CRS}\n";
print "${BRANCH}-HF${nextver}-${ISSUE_TYPE}-${CRS}\n";
