#!/usr/bin/perl

# Set to 1 to exec Jenkins job via wget
$WGET=0;

$offline="no";

if ($offline eq "yes" ) {

print<<EOF;

<html>
<head>
<title>Automated QA Smoketests - Roll Your Own</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
<link rel="stylesheet" href="smoke.css" type="text/css"/>
<body>
<p><img src="https://jenkins.bit9.local/smoke-roll-your-own.jpg" width="600" height=160>
<img src="https://jenkins.bit9.local/smoketesting.jpg" width="160" height=160></p>
<p>

<h1>This utility is being worked on right now and will be back up soon.</h1>
</body>
</html>

EOF

exit 1;
}


# This script processes supplied Linux and/or Mac installer file(s), adds them to a
# Manifest (INI) file and puts it under the \\eng-file-server\builds\BuildNotifications
# directory so the QA smoketest environment can process the request.

use File::Basename;
use IO::Handle;
use LWP::Simple;
use CGI;
use CGI::Carp qw ( fatalsToBrowser );

# Platform OS arrays for OSs so they can support multiple versions
@REDHAT5 = qw(REDHAT57 REDHAT58);
@REDHAT6 = qw(REDHAT63);
@UBUNTU10 = qw(UBUNTU10);
@MAC = qw(MAC);

$email_address = $ENV{REMOTE_USER} . "\@bit9.com";

# limit the allowable size of an uploaded file to 8GB for now
$CGI::POST_MAX = 1024 * 1000000;

$safe_filename_characters = "a-zA-Z0-9_.-";
$upload_top = "/tmp/smoke/uploads";
$engfileserver_builds = "/mnt/builds";
$jenkins_file="$upload_top/jenkins_job.db";
$hourminute=`date +%H%M`;
chomp($hourminute);
$datetime=`date +%m-%d-%y_%H-%M-%S`;
chomp($datetime);

$thisscript=basename($0);
($thisscript_strip_cgi_ext = $thisscript) =~ s/\.cgi//g;
$urlsuffix="$thisscript_strip_cgi_ext";

$DEBUG=1;
$debuglog="/tmp/$thisscript_strip_cgi_ext.out";
open(DBGOUT, ">>$debuglog") if ($DEBUG);
print DBGOUT "In $thisscript_strip_cgi_ext\n";
print DBGOUT "$thisscript_strip_cgi_ext being run by $email_address\n";

# Just so I can copy the changes made in the smoke-test .cgi to
# smoke.cgi
if ( "$thisscript" eq "smoke.cgi" ) {
	$file_ext="txt";
} else {
	$file_ext="txt2";
}

sub display_error_and_exit {
	print "<br><b><font color=\"red\">######</font></b>";
	print "<br><b><font color=\"red\">#</font></b>";
	print "<br><b><font color=\"red\"># ERROR: </font></b>$_[0]\n";
	print "<br><b><font color=\"red\">#</font></b>";
	print "<br><b><font color=\"red\">######</font></b>";
	exit;
}

sub display_success {
	print "<br><b><font color=\"green\">######</font></b>";
	print "<br><b><font color=\"green\">#</font></b>";
	print "<br><b><font color=\"green\"># SUCCESS: </font></b>$_[0]\n";
	print "<br><b><font color=\"green\">#</font></b>";
	print "<br><b><font color=\"green\">######</font></b>";
}

sub doHeader {
	# Do not put this line in the print EOF section
	#print "Content-type:text/html\r\n\r\n";

print<<EOF;

<html>
<head>
<title>Automated QA Smoketests - Roll Your Own</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
<link rel="stylesheet" href="smoke.css" type="text/css"/>

<SCRIPT TYPE="text/javascript">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=700,height=420,scrollbars=yes');
return false;
}
//-->
</SCRIPT>

<!-- This script only support IE 9 and above -->
<script>
    var ie = false;
</script>
<!--[if lt IE 9]>
  <script>
    ie = 0;
  </script>
<![endif]-->

<script>
if (0 === ie) {
  msg = "Internet Explorer version 8 and below are not supported for this site. Please update your IE version or use Firefox or Chrome";
  alert( msg );
  window.location.href = "https://jenkins.bit9.local/$urlsuffix";
}
</script>

<!--script type="text/javascript">
<!--[if lt IE 8]>
  msg = "Internet Explorer version 8 and below are not supported for this site. Please use Firefox or Chrome";
  alert( msg );
  window.location.href = "https://jenkins.bit9.local/$urlsuffix";
<![endif]-->
</script-->

</head>
<body>

<p><img src="https://jenkins.bit9.local/smoke-roll-your-own.jpg" width="600" height=160>
<img src="https://jenkins.bit9.local/smoketesting.jpg" width="160" height=160></p>
<p>

<div class="section">
<table border="1" width="90%">

<form name="myform" action="https://eng.bit9.local/$urlsuffix" enctype="multipart/form-data" method="POST">

<div class="section">

<H2>This page allows engineers to submit Linux/MacOS *.bsx file installers to the QA Smoketest environment</H2>
<p>
<h2>Your email address:</h2>
<input name="email_address" value="$email_address"> If this is not your email address, please correct it

<p>
<!--
<h2>Case Number:</h2>
<input name="casenumber" value="0"> <a href="https://eng.bit9.local/support_help_case.html" onClick="return popup(this, 'notes')"><img src="https://jenkins.bit9.local/help.gif" alt="Support Help Case number" width="16" height="16" border="0" /></a> Please supply a case number. If you don't have one, the default will be zero
-->

Bit9 Release to test:<br>
<select name="bit9Release" size="1"
<option value=" " selected="V720"> </option>
<option value="7.2.0">V720</option>
<option value="7.0.1">Ares-7.0.1-V2</option>
</select>
<br>

<h2>Upload the *.bsx installer file(s) to smoketest. These MUST be installers for the "Bit9 Release to test" you chose above</font> </h2>
<p>
<!--
Please specify a file, or a set of files: <a href="https://eng.bit9.local/support_help_file_info.html" onClick="return popup(this, 'notes')"><img src="https://jenkins.bit9.local/help.gif" alt="Support Help Case number" width="16" height="16" border="0" /></a>
-->
Please specify a file, or a set of files:
<br>
<input type="file" name="datafiles" multiple="true" size="60">
</p>

<div>
<input type="submit" value="Submit"> (Once your submission is complete, your smoketest configuration details will be printed below:)<br>
</div>

</form>

EOF

}

print DBGOUT "ENV{'REQUEST_METHOD'} is \"$ENV{'REQUEST_METHOD'}\"\n" if ($DEBUG);

$query = new CGI;

if ($ENV{'REQUEST_METHOD'} eq "GET") {
	# Print the "Content-type:text/html\r\n\r\n" string using the CGI lib
	print $query->header ( );
	&doHeader;
	exit;
}

$bit9Release = $query->param("bit9Release");
$filename = $query->param("datafiles");
$email_address = $query->param("email_address");

#$email_address = $ENV{REMOTE_USER} . "\@bit9.com";
if ( !$filename ) {
	print $query->header ( );
	&doHeader;
	&display_error_and_exit("There was a problem uploading your datafile(s) (try a smaller file)");
}

$upload_dir = "$upload_top/$ENV{REMOTE_USER}/$datetime";

# use the fileparse routine in the File::Basename module to split the filename
# into its leading path (if any), the filename itself, and the file extension.
# We can then safely ignore the leading path. Not only does this help thwart
# attempts to save the file anywhere on the web server, but some browsers send
# the whole path to the file on the users hard drive
($name, $path, $extension) = fileparse ( $filename, '\..*' );
$filename = $name . $extension;

print DBGOUT "name is \"$name\"\n";
print DBGOUT "path is \"$path\"\n";
print DBGOUT "extension is \"$extension\"\n";

# Make sure this was a valid file extension. If the filename has mulitple dots
# in the name, the $extension will contain more than just the extension. Thats
# why I do a regexp compare.
@out=`env`;
foreach $line (@out) {
	chomp $line;
	#print DBGOUT "$line\n";
}
print DBGOUT "File extension is $extension\n";
if ( $extension !~ "\.bsx" ) {
     print $query->header ( );
     &doHeader;
     &display_error_and_exit("Invalid installer file: The only supported installer file type is .bsx)");
}

# remove any characters that aren't in our safe character list
$filename =~ tr/ /_/; $filename =~ s/[^$safe_filename_characters]//g;

# Finally, to make doubly sure that our filename is now safe, well match it
# against our $safe_filename_characters regular expression, and extract the
# characters that match (which should be all of them). We also need to do this
# to untaint the $filename variable. This variable is tainted because it
# contains potentially unsafe data passed by the browser. The only way to
# untaint a tainted variable is to use regular expression matching to extract
# the safe characters:
if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {
	$filename = $1;
} else {
	die "Filename contains invalid characters";
}

# use the upload method to grab the file handle of the uploaded file
# (which actually points to a temporary file created by CGI.pm)

print DBGOUT "mkdir -p \"$upload_dir\"\n" if ($DEBUG);
$status=system("/bin/mkdir -p $upload_dir");
print DBGOUT "mkdir -p \"$upload_dir\" status is $status\n" if ($DEBUG);

@upload_filehandle = $query->upload("datafiles");
print DBGOUT "upload_filehandle array is \"@upload_filehandle\"\n" if ($DEBUG);
foreach $fh (@upload_filehandle) {
	print DBGOUT "fh is \"$fh\"\n" if ($DEBUG);
	print DBGOUT "$upload_dir/fh is \"$upload_dir/$fh\"\n" if ($DEBUG);
	open ( UPLOADFILE, ">$upload_dir/$fh" ) or die "$!";
	binmode UPLOADFILE;
	while ( <$fh> ) {
		print UPLOADFILE;
	}
	close UPLOADFILE;
}

# Rename long pathed filenames to their bansenam
chdir("$upload_dir");
@files=`ls`;
chomp @files;
foreach $file (@files) {
	#$file =~ s/\\/\//g;
	($fsfile = $file) =~ s/\\/\//g;
	$bn=basename($fsfile);
	#print "file is $file\n";
	#print "bn is $bn\n";
	if ( "$file" ne "$bn" ) {
		print "mv $file to $bn\n";
		rename "$file", "$bn";
	}
}

# Process files to see what platforms they're for so we know what to test

open(INI, ">/tmp/tfs$$");
print INI "[GENERAL]\n";
print INI "Platforms = ";

@OSS=();
@PLATFORMS_W_COMMAS=();

@files=`ls`;
chomp @files;
foreach $file (@files) {
	$status = system("grep -a \"\/Applications\" $file > /dev/null 2>&1");
	if (!$status) {
		$OSVER="Mac";
	}
	$status = system("grep -a \"INSTALL_PLATFORM=\" $file > /dev/null 2>&1");
	if (!$status) {
		$OSVER=`grep -a \"INSTALL_PLATFORM=\" $file | cut -d= -f2`;
		chomp($OSVER);
	}
	$found=0;
	foreach $os (@OSS) {
		if ( $os eq $OSVER ) {
			$found=1;
			last;
		}
	}
	push(@OSS, $OSVER);
	if (!$found) {
		print DBGOUT "$file is a $OSVER file\n" if ($DEBUG);
	} else {
		print $query->header ( );
		&doHeader;
		&display_error_and_exit("You cannot supply multiple $OSVER files. Only one *.bsx file per platform are supported: MAC, REDHAT5, REDHAT6 or UBUNTU10");
	}
	$UC_OSVER = uc($OSVER);
	# Do not use "push" for PLATFORMS_W_COMMAS array because space chars are
	# included and I don't want them
	@ARRAY_TO_USE = ();
	@ARRAY_TO_USE = @REDHAT5  if ( $UC_OSVER =~ m/REDHAT5/ );
	@ARRAY_TO_USE = @REDHAT6  if ( $UC_OSVER =~ m/REDHAT6/ );
	@ARRAY_TO_USE = @UBUNTU10 if ( $UC_OSVER =~ m/UBUNTU10/ );
	@ARRAY_TO_USE = @MAC      if ( $UC_OSVER =~ m/MAC/ );
	if ( "@ARRAY_TO_USE" !~ m/./ ) {
		&doHeader;
		&display_error_and_exit("No match for OSVER. Please ask Release Engineering for help");
	} else {
		foreach $osver (@ARRAY_TO_USE) {
			@PLATFORMS_W_COMMAS="@PLATFORMS_W_COMMAS,$osver";
		}
	}
}
# Remove trailing comma from last element in array
#chop($PLATFORMS_W_COMMAS[-1]);
#Strip leading comma
s{^,}{} foreach @PLATFORMS_W_COMMAS;

print INI "@PLATFORMS_W_COMMAS\n";
print INI "Type = US\n";
print INI "Requestor = $ENV{REMOTE_USER}\n";
print INI "RequestorEmail = $email_address\n";
print INI "Directory = \\\\eng-file-server\\builds\\$bit9Release.9999-$ENV{REMOTE_USER}-$hourminute\n";
print INI "Label = $bit9Release.9999-$ENV{REMOTE_USER}-$hourminute\n";
@PLATFORMS_W_SPACES = split ",", $PLATFORMS_W_COMMAS[0];
foreach $plat (@PLATFORMS_W_SPACES) {
	print INI "[$plat]\n";
	print INI "Status = SUCCESS\n";
	print INI "StdErr = None\n";
	print INI "StdOut = None\n";
	print INI "SmokeTest = Yes\n";
}
close(INI);

# Copy the INI file
$status = system("/bin/cp /tmp/tfs$$ $upload_dir/$bit9Release.9999-$ENV{REMOTE_USER}-$hourminute.Success.$file_ext");
if ($status) {
	print $query->header ( );
	&doHeader;
	&display_error_and_exit("Failed to create $buildnotifications_file. Please ask Release Engineering for help");
}

$jenkins_job="Smoke_Roll_Your_Own";

#PUTBACK
if ($WGET) {
	system("wget -q -O - --no-check-certificate --auth-no-challenge --http-user=build --http-password=2a19f9d3a817e3eb49b154183be46104 https://jenkins.bit9.local/ci/job/$jenkins_job/buildWithParameters?File_Location=$upload_dir > /dev/null 2>&1");
}

print $query->header ( );
&doHeader;
&display_success("Your installer file(s) have been successfully uploaded!");

print <<END_HTML;
<p>Your email address: <b>$email_address</b></p>
<p>You will receive an email when your smoketests are complete</p>
<p> The *.bsx files you submitted produced the following smoketest configuration:</p>

--------
END_HTML

open(TMPIN, "/tmp/tfs$$");
while ( $line = <TMPIN>) {
	chomp $line;
	next if ( $line =~ m/Std/ );
	if ( $line =~ m/\[GENERAL/ or $line =~ m/\[MAC/ or $line =~ m/\[REDHAT/ or $line =~ m/\[UBUNTU/ ) {
		print "<br><b><font color=\"blue\">$line</font></b>";
	} elsif ( $line =~ m/Directory/ ) {
		print "<br><b><font color=\"dodgerblue\">$line</font></b>";
	} elsif ( $line =~ m/SmokeTest/ or $line =~ m/Status/ ) {
		print "<br><b><font color=\"green\">$line</font></b>";
	} else {
		print "<br>$line\n";
	}
}
close(TMPIN);
unlink("/tmp/tfs$$");

print <<END_HTML2;
<br>--------<br><br><br><br>
</body>
</html>

END_HTML2

close(DBGOUT) if ($DEBUG);

exit 0;
