#!/usr/bin/perl

# Script to query TestTrack smoketest database for a particular build to see if all the platforms
# have completed. If they have, do something such as send out email notification that their smoketests
# are complete and look for results.
# If build is complete, the result will be 1.  Otherwise the result is 0

use DBI;
use File::Basename;

if ( "$ARGV[0]" !~ m/./ ) {
	print "Error: Missing build type \"ci\" or \"demand\" as arg0\n";
	exit 1;
}

if ( "$ARGV[1]" !~ m/./ ) {
	print "Error: Missing build name as arg1\n";
	exit 1;
}

# Set to 1 for live TestTrack/TestTrack SQL database
$LIVEDB="1";

# Used for live TestTrack instance
$db_port="61933";
#$db_server = "10.0.3.110";
$db_server = "it-sql-2012.bit9.local";
$db_name = "TestResults";
$db_user = "TestExecutionFramework";
$db_pass = "TestExecutionFramework";

$date=`date`;
chomp($date);

$thisscript=basename($0);
($thisscript_strip_ext = $thisscript) =~ s/\.pl//g;
if ( "$thisscript" eq "smokestats-sqlquery-status.pl" ) {
	$debuglog="/tmp/smokestats-sqlquery-status.out";
} else {
	$debuglog="/tmp/smokestats-sqlquery-status-test.out";
}

$CONNECT = "DRIVER={SQL Server Native Client 11.0};Server=$db_server,$db_port;Database=$db_name;UID=$db_user;PWD=$db_pass";

$dbh = DBI-> connect("dbi:ODBC:$CONNECT");

# I want to get all records and let this script parse the valid
$build="$ARGV[1]";

# Example command for staus complete query
# SELECT * FROM [TestResults].[dbo].[IsCISmokeTestRunComplete] (<TargetBuild>, <TargetPlatform>)

if ( $ARGV[0] eq "ci" ) {
	$sql = "SELECT * FROM [TestResults].[dbo].[IsCISmokeTestRunComplete] ('$build', '')";
} else {
	$sql = "SELECT * FROM [TestResults].[dbo].[IsDemandSmokeTestRunComplete] ('$build', '')";
}

# Prepare the statement.
$sth = $dbh->prepare($sql) or die "Can't prepare statement: $DBI::errstr";
# Execute the statement.
$sth->execute();

# Fetch and display the result set value.

while ( @row = $sth->fetchrow_array ) {
	#print "row array is \"@row\"\n";
	if ( "@row" == 1 ) {
		print "Smoketest status: Complete\n";
	} elsif ( "@row" == 0 ) {
		print "Smoketest status: Running\n";
	} else {
		print "Smoketest status: Unknown\n";
	}
}

# Disconnect the database from the database handle.
$dbh->disconnect;
