#!/usr/bin/perl

$offline="no";
#$offline="yes";


if ($offline eq "yes" ) {

print<<EOF;

<html>
<head>
<title>SSupport Page for Customer File Reports</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
<link rel="stylesheet" href="support.css" type="text/css"/>
<body>
<p><img src="https://$ENV{'SERVER_NAME'}/Customer_Decryption_Page.jpg" width="600" height=160>
<img src="https://$ENV{'SERVER_NAME'}/folder-lock.jpg" width="160" height=160></p>
<p>

<h1><font color="red">Temporarily down for maintenance</font></h1>
We expect to be up shortly. Thanks for your patience.
</body>
</html>

EOF

exit 1;
}


# This script takes a file chosen from the form and processes it. This is used
# for customer supplied encrypted files for Support to use to decrypt and
# generate appropiate reports.

use File::Basename;
use File::Path;
use IO::Handle;
use LWP::Simple;
use CGI;
use CGI::Carp qw ( fatalsToBrowser );
use URI::Escape;

# CEL $email_address = $ENV{'REMOTE_USER'} . "\@bit9.com";
$username = $ENV{'REMOTE_USER'};
$email_address = "$username\@carbonblack.com";

# limit the allowable size of an uploaded file to 8GB for now
$CGI::POST_MAX = 1024 * 8000000;

$safe_filename_characters = "a-zA-Z0-9_.-";
$upload_top = "/tmp/support/uploads";
$jenkins_file="$upload_top/jenkins_job.db";
$date=`date`;
chomp($date);
$datetime=`date +%F-%T`;
$datetime =~ s/:/-/g;
chomp($datetime);

$thisscript=basename($0);
($thisscript_strip_cgi_ext = $thisscript) =~ s/\.cgi//g;

$DEBUG=1;
$debuglog="/tmp/$thisscript_strip_cgi_ext.out";
open(DBGOUT, ">>$debuglog") if ($DEBUG);
print DBGOUT "$date: In $thisscript_strip_cgi_ext\n";
print DBGOUT "$date: $thisscript_strip_cgi_ext being run by $email_address\n";

sub doHeader {
	# Do not put this line in the print EOF section
	#print "Content-type:text/html\r\n\r\n";

print<<EOF;

<html>
<head>
<title>Support Page for Customer File Reports</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
<link rel="stylesheet" href="support.css" type="text/css"/>

<SCRIPT TYPE="text/javascript">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=700,height=420,scrollbars=yes');
return false;
}
//-->
</SCRIPT>

</head>
<body>

<p><img src="https://$ENV{'SERVER_NAME'}/Customer_Decryption_Page.jpg" width="600" height=160>
<img src="https://$ENV{'SERVER_NAME'}/folder-lock.jpg" width="160" height=160></p>
<p>

<div class="section">
<table border="1" width="90%">

<form name="myform" action="https://$ENV{'SERVER_NAME'}/$thisscript_strip_cgi_ext" enctype="multipart/form-data" method="POST">

<div class="section">

<H2>This page is used to decrypt customer data files - <b><font color=green>NOTICE:</b> The decryption of MAC/Linux cache/server DB files and encrypted database key files is now supported!</font></H2>
<p>
<h2>Your email address:</h2>
<input name="email_address" value="$email_address"> If this is not your email address, please correct it

<p>
<h2>Case Number:</h2>
<input name="casenumber" value="0"> <a href="https://$ENV{'SERVER_NAME'}/support_help_case.html" onClick="return popup(this, 'notes')"><img src="https://$ENV{'SERVER_NAME'}/help.gif" alt="Support Help Case number" width="16" height="16" border="0" /></a> Please supply a case number. If you don't have one, the default will be zero

<h2>Upload the customer file(s) to process (Only .zip, .db, .dmp, .etl and .enc (encrypted DB key) file types are allowed). Make sure that no files start with LL, as you will be unable to download them after decryption. <font color="red">Note: The *.dmp file converter is not available at this time but will be added later</font> </h2>
<p>
Please specify a file, or a set of files: <a href="https://$ENV{'SERVER_NAME'}/support_help_file_info.html" onClick="return popup(this, 'notes')"><img src="https://$ENV{'SERVER_NAME'}/help.gif" alt="Support Help Case number" width="16" height="16" border="0" /></a>
<br>
<input type="file" name="datafiles" multiple="true" size="60">
</p>
<p>
<br>
<h2>Password for archive:</h2>
<input type="password" name="zippassword" value="">
Only supply a password if the customer has supplied an encrypted ZIP file. Otherwise please leave blank.
</p>

<div>
<input type="submit" value="Submit"> (Once your submission is complete, you will receive an email with your data)<br>
</div>

</form>

EOF

}

##
## Starting processing form request
print DBGOUT "$date: ENV{'REQUEST_METHOD'} is \"$ENV{'REQUEST_METHOD'}\"\n" if ($DEBUG);

$query = new CGI;

if ($ENV{'REQUEST_METHOD'} eq "GET") {
	# Print the "Content-type:text/html\r\n\r\n" string using the CGI lib
	print $query->header ( );
	&doHeader;
	exit;
}

$casenumber = $query->param("casenumber");
if ( $casenumber !~ m/./ ) {
	print $query->header ( );
	print "You must supply a case number. If you don't have one, the default will be zero.";
	exit;
}

# jack - remove/trim both ends of extra white space (support will copy and paste and get extra spaces which can mess up folder and upload_dir)
$casenumber =~ s/^\s+|\s+$//g;

$filename = $query->param("datafiles");
$email_address = $query->param("email_address");
my ($username, $domain) = split /\@/, $email_address;
if ( !$filename ) {
	print $query->header ( );
	print "There was a problem uploading your datafile(s) (try a smaller file).";
	exit;
}
$zippassword = $query->param("zippassword");
if ( !$zippassword ) {
    print DBGOUT "No password entered\n";
}
else {
#    print DBGOUT "$date: zippassword is \"$zippassword\"\n";
    $encoded_zip_password = uri_escape($zippassword)
}

$user_dir = "$upload_top/$username";

# use the fileparse routine in the File::Basename module to split the filename
# into its leading path (if any), the filename itself, and the file extension.
# We can then safely ignore the leading path. Not only does this help thwart
# attempts to save the file anywhere on the web server, but some browsers send
# the whole path to the file on the users hard drive
($name, $path, $extension) = fileparse ( $filename, '\..*' );
$filename = $name . $extension;

print DBGOUT "$date: name is \"$name\"\n";
print DBGOUT "$date: path is \"$path\"\n";
print DBGOUT "$date: extension is \"$extension\"\n";

# Make sure this was a valid file extension. If the filename has mulitple dots
# in the name, the $extension will contain more than just the extension. Thats
# why I do a regexp compare.
@out=`env`;
foreach $line (@out) {
	chomp $line;
	#print DBGOUT "$line\n";
}
print DBGOUT "$date: File extension is $extension\n";
if ( $extension !~ "\.zip" and
     $extension !~ "\.db" and
     $extension !~ "\.dmp" and
     $extension !~ "\.etl" and 
     $extension !~ "\.enc" ) {
     print $query->header ( );
     print "Invalid file type: Supported file types are: .zip, .db, .dmp, .etl and .enc (encrypted DB key file)\n";
     exit;
}

# remove any characters that aren't in our safe character list
$filename =~ tr/ /_/; $filename =~ s/[^$safe_filename_characters]//g;

# Finally, to make doubly sure that our filename is now safe, well match it
# against our $safe_filename_characters regular expression, and extract the
# characters that match (which should be all of them). We also need to do this
# to untaint the $filename variable. This variable is tainted because it
# contains potentially unsafe data passed by the browser. The only way to
# untaint a tainted variable is to use regular expression matching to extract
# the safe characters:
if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {
	$filename = $1;
} else {
	die "Filename contains invalid characters";
}

# use the upload method to grab the file handle of the uploaded file
# (which actually points to a temporary file created by CGI.pm)
$upload_dir = "$upload_top/$username/$casenumber/$datetime";

if ( -d "$user_dir" ){
  print DBGOUT "Removing $user_dir\n" ;
  $delete_dir = rmtree("$user_dir") ;
}

print DBGOUT "$date: mkdir -p \"$upload_dir\"\n" if ($DEBUG);
$status=system("/bin/mkdir -p $upload_dir");
print DBGOUT "$date: mkdir -p \"$upload_dir\" status is $status\n" if ($DEBUG);

@upload_filehandle = $query->upload("datafiles");
print DBGOUT "$date: upload_filehandle array is \"@upload_filehandle\"\n" if ($DEBUG);
foreach $fh (@upload_filehandle) {
	print DBGOUT "$date: fh is \"$fh\"\n" if ($DEBUG);
	print DBGOUT "$date: $upload_dir/fh is \"$upload_dir/$fh\"\n" if ($DEBUG);
	open ( UPLOADFILE, ">$upload_dir/$fh" ) or die "$!";
	binmode UPLOADFILE;
	while ( <$fh> ) {
		print UPLOADFILE;
	}
	close UPLOADFILE;
}

chdir("$upload_dir");
@files=`ls`;
chomp @files;
foreach $file (@files) {
	#$file =~ s/\\/\//g;
	($fsfile = $file) =~ s/\\/\//g;
	$bn=basename($fsfile);
	#print "file is $file\n";
	#print "bn is $bn\n";
	if ( "$file" ne "$bn" ) {
		print DBGOUT "mv $file to $bn\n";
		rename "$file", "$bn";
	}
}
chdir("/tmp");

# Execute the Jenkins job to process the request. I'm not sure why I have to
# mess with stdout/stderr but the -O and -q options still let output thru that
# causes this final page display to fail

if (length $test_jenkins_job) {
	$jenkins_job="$test_jenkins_job";
} else {
	$jenkins_job="New_Customer_Decrypt_Cache";
	print DBGOUT "Using job: $jenkins_job\n";
}

close(DBGOUT) if ($DEBUG);

#system("wget -q -O - --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/ci/job/$jenkins_job/buildWithParameters?File_Location=$upload_dir\\&token=BIT9_TOKEN > /dev/null 2>&1");
if ( !$zippassword ) {
    print DBGOUT "No password entered\n";
    system("wget -q -O - --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/job/$jenkins_job/buildWithParameters?CachePath=$upload_dir/$filename\\&token=BIT9_TOKEN > /dev/null 2>&1");
}
else {
    print DBGOUT "$date: zippassword is \"$zippassword\"\n";
    system("wget -q -O - --no-check-certificate --auth-no-challenge --http-user=build --http-password=bdf12eed0129c2c54deb96597cbace18 https://jenkins.bit9.local/job/$jenkins_job/buildWithParameters?CachePath=$upload_dir/$filename\\&ZipPassword=$encoded_zip_password\\&token=BIT9_TOKEN > /dev/null 2>&1");
}

print $query->header ( );

print <<END_HTML;

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd"> <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> <head> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <title>Thanks!</title> <style type="text/css"> img {border: none;} </style> </head> <body> <p>Your datafile(s) has been successfully uploaded!</p> <p>Your email address: $email_address</p><p>up:$upload_dir</p> <p>A link to your datafile(s) reports will be emailed to you shortly.</p> <p><a href=javascript:history.back()>Return to Support page</a> </p> </body> </html>

END_HTML


exit 0;
