#!/usr/bin/perl

$hostname=`hostname`;
chomp $hostname;

if ( "$hostname" != "jenkins" ) {
        print "\nERROR: Must be run from host jenkins\n\n";
        exit 1;
}

$pwfile="/var/www/.testtrack/.BiT9paSsIn0rD";

if ( ! -f "$pwfile" ) {
        print "\nERROR: Could not find $$pwfile\n\n";
        exit 1;
}

use DBI;
use File::Basename;

$date=`date`;
chomp($date);

# TestTrack numbers input. If space separated, substitute comma delimiters
#print "ARGV[0] is \"$ARGV[0]\"\n";
($argin = $ARGV[0]) =~ s/\ /,/g;
#print "argin is \"$argin\"\n";
@tt_numbers = split ',', $argin;
#print "tt_numbers array is \"@tt_numbers\"\n";

# CONFIG VARIABLES
$host = "localhost";
$database = "SvnChangeRequests";
#$tablename = "tt_records";
$user = "root";

open(PW, "$pwfile") or die "Error opening $pwfile";
while(<PW>) {
	next if (m/#/);
	$pw="$_";
	chomp $pw;
}
close(PW);

$svn_repo_top="https://subversion.bit9.local/svn";

# https://subversion.bit9.local:6443/fisheye/changelog/bit9installers?cs=3149
$fisheye_url="https://subversion.bit9.local:6443/fisheye/changelog";

$dbh = DBI->connect("DBI:mysql:$database:$host", "$user", "$pw")
  or die "Cannot connect: " . $DBI::errstr;

@REPOS = qw(Das DasThirdParty bit9installers build);
#@REPOS = qw(Das);
#@REPOS = qw(bit9installers);

foreach $repo (@REPOS) {

	$query="norecords";

	print "\n<h2>SVN Repo: $repo</h2>\n";

	$sql_table = "tt_records_" . "$repo";
	$sql = qq`SELECT * FROM $sql_table`;

	# Prepare the statement.
	$sth = $dbh->prepare($sql) or die "Can't prepare statement: $DBI::errstr";
	# Execute the statement.
	$sth->execute();

	# Fetch and display the result set value.
	$count=1;
	open(DBG, ">>/tmp/sqlsmoke.out");
	while ( @row = $sth->fetchrow_array ) {
        	#print "1 - row[0] \"$row[0]\"\n";
		foreach $ttnum (@tt_numbers) {
			#print "ttnum is \"$ttnum\"\n";

#print "<tr class=\"even\">\n<td width=\"10%\" align=\"left\">SVN Action</td>\n";

			if ( $row[0] eq $ttnum ) {

				# Number of elements in array
				#$row_array_cnt = scalar @row;

				#print "ZZZ row array is \"@row\" YYY\n";
				#print "row_array_cnt is \"$row_array_cnt\"\n";

				$query="hasrecords";
				print "<table border=\"0\">\n";
				print "<tr class=\"odd\">\n";
				print "<td><b>TestTrack #</b>: </td>\n";
				print "<td><b>$row[0]</b></td>\n";
				print "</tr>\n";

				@svn_version_array = split ' ', "$row[1]";
				@svn_author_array = split ' ', "$row[2]";
				@svn_commitdate_array = split ' ', "$row[3]";
				@svn_branch_array = split ' ', "$row[4]";

				#print "svn_version_array is \"@svn_version_array\"\n";
				#print "svn_author_array is \"@svn_author_array\"\n";
				#print "svn_commitdate_array is \"@svn_commitdate_array\"\n";
				#print "svn_branch_array is \"@svn_branch_array\"\n";

				$rcnt=0;
				foreach $record (@svn_version_array) {
					$record =~ s/r//g;
					print "<tr class=\"odd\">\n";
					print "<td>SVN Version: </td>\n";
					print "<td><a href=\"$fisheye_url/$repo?cs=$record\" target=_blank>$record</td>\n";
					print "</tr>\n";

					print "<tr class=\"odd\">\n";
					print "<td>SVN Author: </td>\n";
					print "<td>$svn_author_array[$rcnt]</td>\n";
					print "</tr>\n";

					print "<tr class=\"odd\">\n";
					print "<td>SVN Commit Date: </td>\n";
					print "<td>$svn_commitdate_array[$rcnt]</td>\n";
					print "</tr>\n";

					print "<tr class=\"odd\">\n";
					print "<td>SVN Branch: </td>\n";
					print "<td>$svn_branch_array[$rcnt]</td>\n";
					print "</tr>\n";

					print "<tr class=\"odd\">\n";
					print "<td>-----</td>\n";
					print "</tr>\n";
					$rcnt++;
				}

        			#print "row[0] \"$row[0]\"\n";
        			#print "row[1] \"$row[1]\"\n";
        			#print "row[2] \"$row[2]\"\n";
        			#print "row[3] \"$row[3]\"\n";
        			#print "row[4] \"$row[4]\"\n";
        			#print "row array \"@row\"\n";
				print "</table>\n";
			}
		}
	}
	if ( $query eq "norecords" ) {
		print "<table border=\"0\">\n";
		print "<tr class=\"even\"><td>No records found</td></tr>\n";
		print "</table>\n";
		#print "No records found\n";
	}
	print "</td>\n";
}

## Disconnect the database from the database handle.
$dbh->disconnect;
