#!/usr/bin/perl

use File::Basename;
use IO::Handle;
use Sys::Hostname;

$host = hostname;

$thisscript=basename($0);
$progdir=dirname($0);
($thisscript_strip_cgi_ext = $thisscript) =~ s/\.cgi//g;
$fisheye="https://subversion.bit9.local/fisheye/browse";

# So I can change the test script before making it live
if ( "$thisscript" eq "testtrack-branch-commits.cgi" ) {
        $sql_query_script="$progdir/svn_testtrack.pl";
} else {
        $sql_query_script="$progdir/svn_testtrack-test.pl";
}

#$sql_query_script="$progdir/svn_testtrack.pl";

$DEBUG=1;
$debuglog="/tmp/$thisscript_strip_cgi_ext.out";
open(DEBUGOUT, ">>$debuglog") if ($DEBUG);
print DEBUGOUT "In $thisscript_strip_cgi_ext\n";

sub printError() {
	# Do not put this line in the print EOF section
	#print "Content-type:text/html\r\n\r\n";

print<<EOF;
<html>
<head>
<title>Display SVN commit info for TestTrack Change Requests</title>
<link rel="stylesheet" href="testtrack-svn-commits.css" type="text/css"/>
</head>
<body>

<p>

<font color="red"><b>ERROR: </b></font> $_[0]

</body>
</html>

EOF

}

sub ReadParse {
	local (*in) = @_ if @_;
	local ($i, $loc, $key, $val);

	# Read in text
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$in = $ENV{'QUERY_STRING'};
	} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
	}

	@in = split(/&/,$in);

	foreach $i (0 .. $#in) {
		# Convert pluses to spaces
		$in[$i] =~ s/\+/ /g;

		# Split into key and value.
		($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

		# Convert %XX from hex numbers to alphanumeric
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		$val =~ s/%(..)/pack("c",hex($1))/ge;

		# Associate key and value
		$in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
		$in{$key} .= $val;
		if ( $key =~ /TestTrackNumbers/ ) {
			$TestTrackNumbers="$val";
			#print DEBUGOUT "TestTrackNumbers is \"$TestTrackNumbers\"\n" if ($DEBUG);
		} elsif ( $key =~ /toVersion/ ) {
			$toVersion="$val";
			#print DEBUGOUT "toVersion is \"$toVersion\"\n" if ($DEBUG);
		}
	}

	if (0) {
	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$num_of_dots_TestTrackNumbers = $TestTrackNumbers =~ tr/\.//;
		$num_of_dots_toVersion = $toVersion =~ tr/\.//;
		if ($num_of_dots_TestTrackNumbers < 3 or $num_of_dots_toVersion < 3) {
			print DEBUGOUT "Error: Invalid version specified\n";
			&printError("Invalid version specified. Please use x.x.x.x formatted build version string for both fields");
			open (STDOUT, ">&ORIGSTDOUT") or die "Can't restore STDOUT: $!"; 
			close ORIGSTDOUT; 
			system("cat $TF1");
			unlink("$TF1");
			exit 0;
		}
	}
	}
}

# Just so I can copy the chnages made in the diffbuilds-test .cgi to
# diffbuilds.cgi
if ( "$thisscript" eq "diffbuilds.cgi" ) {
        $svnrepostring_url="svn";
        $svnrepostring="repos";
} else {
        $svnrepostring_url="svntest";
        $svnrepostring="testrepos";
	# Force live SVN so I can pick up live data for test run
	#$svnurl="https://subversion.bit9.local/svn";
}
$svnurl="https://subversion.bit9.local/$svnrepostring_url";

sub doHeader {
	# Do not put this line in the print EOF section
	print "Content-type:text/html\r\n\r\n";

print<<EOF;
<html>
<head>
<title>Display SVN commit info for TestTrack Change Requests</title>
<link rel="stylesheet" href="testtrack-svn-commits.css" type="text/css"/>
</head>
<body>

<p><img src="https://$host.bit9.local/testtrack-branch-commits.jpg" width="600" height=160>
<img src="https://$host.bit9.local/testtrack-logo.png" width="120" height=125>
<p>

<table border="1" width="90%">

<form name="myform" action="https://$host.bit9.local/$thisscript_strip_cgi_ext" method="POST">

<h2>Supply the TestTrack number(s) to display SVN branch commits (i.e 12345 or 45678,54321,99999)</h2>

TestTrack numbers:
<INPUT NAME="TestTrackNumbers" size="120">
</SELECT>
(Multiple TestTrack numbers must be comma or space separated)
<p>
<input type="submit" value="Submit">
</form>

EOF

}

# I redirect STDOUT to a file so I can process the file and put info at the top
# of the output. For me to get the info I need, the script needs to run first so
# I can't just print to STDOUT directly.

$TF1="/tmp/tf1$$";
#$TF1="/tmp/tf1ZZZ";
# Save original STDOUT
open (ORIGSTDOUT, ">&STDOUT") or die "Couldn't dup STDOUT: $!";
open (STDOUT, ">> $TF1") or die "Can't open $TF1: $!";

#print DEBUGOUT "ENV{'REQUEST_METHOD'} is \"$ENV{'REQUEST_METHOD'}\"\n" if ($DEBUG);

#if ( $ENV{'REQUEST_METHOD'} or $ENV{'REQUEST_METHOD'} eq "POST") {
if ( $ENV{'REQUEST_METHOD'} ) {
	&doHeader;

	&ReadParse;

	#if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
	if ( "$TestTrackNumbers" =~ m/./ ) {
		# If user supplies spaces between TT #s, replace with commas
		if ( $TestTrackNumbers =~ m/\ / ) {
			$TestTrackNumbers =~ s/\ /,/g;
		}
		#&getSVNdata("$TestTrackNumbers");

		system("perl $sql_query_script $TestTrackNumbers");
		if (0) {
		@out=`perl $sql_query_script $TestTrackNumbers`;
		#open(OUTTY, ">/tmp/rrr.out");
		#print OUTTY "$sql_query_script $TestTrackNumbers\n";
		foreach $line (@out) {
			#print OUTTY "<br>$line\n";
			print "$line\n";
		}
		}

		#close(OUTTY);
	}
	print "</body></html>\n";
}

close STDOUT;
# Restore original STDOUT 
open (STDOUT, ">&ORIGSTDOUT") or die "Can't restore STDOUT: $!"; 
close ORIGSTDOUT; 
#system("cat $TF1 | sed s/FILES_CHANGED/$count/g");
system("cat $TF1");
unlink("$TF1");
$datenow=`date`;
chomp $datenow;
print DEBUGOUT "Run $datenow by: $ENV{REMOTE_USER}\n";
if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
	print DEBUGOUT "TestTrack query: $TestTrackNumbers\n";
}
close(DEBUGOUT) if ($DEBUG);

exit 0;
